<?php
/**
 * @subpackage	mod_btwitter
 * @copyright	Copyright (C) 2012 Ben Tasker . All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */




// no direct access
defined('_JEXEC') or die;

class modBuggerChangeLogHelper
{
	
function setparams($params){
$this->params = $params;
}




function getChangelog(){

$project = $this->params->get('Project');
$order = $this->params->get('Order');
//$installid = $this->params->get('InstID');
$cachetime = $this->params->get('shortcache');

$uri = "http://projects.bentasker.co.uk/auto.php?action=changelog&Project=$project&rev=$order&format=json";


if ($this->params->get('CachingEnabled')){
// Get the config object from factory
        $conf =& JFactory::getConfig();
        // Get the current cachetime value
        $oldcachetime = $conf->getValue('config.cachetime');
        
	
	// Set the cache time to 30 mins 
        $conf->setValue('config.cachetime', $cachetime);
	



        // Get the Cache object
        $cache =& JFactory::getCache('mod_buggerchangelog'.$project.$order, 'output');
        // Enable caching (if disabled in global configuration)
        $cache->setCaching( 1 );
        // Try to get the results from cache


    if (!($json = $cache->get('mod_buggerchangelog_log'.$project.$order))) {
                                   
            if ($json = $this->place_request($uri)) {
                // Store the data in cache
                if (!$cache->store($json, 'mod_buggerchangelog_log'.$project.$order)) {
                    // If storing in cache failed then we will return the error
                    $error = 'cache';
                }
            } else {
                $error = 'Could not retrieve';
            }
        }


// Reset the cachetime
$conf->setValue('config.cachetime', $oldcachetime);

return json_decode($json);

    }else{
// Caching Disabled, just place the request
return json_decode($this->place_request($uri));
    }

}



function place_request($uri){


unset($this->result);

// Check whether we can use File or if we need to resort to Curl
if (ini_get('allow_url_fopen')){
$this->result = implode("\n",$this->placefilerequest($uri));
}else{
$this->result = $this->placecurlrequest($uri);

}







return $this->result;
}








function placefilerequest($uri){
$results = file("$uri");


return $results;
}


function placecurlrequest($uri){
 $ch = curl_init("$uri");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
 
    $data = curl_exec($ch);
 
    curl_close($ch);

return $data;
}


}
